#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "syscall.h"

static int sys_own_call( char *str, int len ) {
   long __res;
   __asm__ volatile (
      "int $0x80":
     "=a" (__res):"a"(__NR_own),"b"((long)(str)),"c"((long)(len)) );
   return -((int)__res);
}

static void do_own_call( char *str ) {
   int n = sys_own_call( str, strlen( str ) );
   printf( "syscall return %d : %s\n", n, strerror( n ) );
} 

int main( int argc, char *argv[] ) {
   char str[] = "DEFAULT STRING";
   if( 1 == argc ) do_own_call( str );
   else
      while( --argc > 0 ) do_own_call( argv[ argc ] );
   return EXIT_SUCCESS;
};

